<template>
	<div>
		<template-page v-if="!isShowMemberDetail" ref="pageRef" :get-list="getList" :table-attributes="tableAttributes" :table-events="tableEvents" :operationColumnWidth="200"
		  :options-evens-group="optionsEvensGroup" :moreParameters="moreParameters" :column-parsing="columnParsing"
		  :operation="operation">
		 <!-- :exportList="exportList" -->
		  <el-dialog title="" width="500px" custom-class="diy-dialog" append-to-body :modal="true" :visible.sync="formDialog"
		    :show-close="true" :close-on-click-modal="false" :modal-append-to-body="false" :before-close="formCancel">
		    <zj-form-container ref="formRef" :form-data="formData" :styleSwitch="false">
		      <zj-form-module :title="formDialogTitles[formDialogType]" label-width="100px" :showPackUp="false"
		        :form-data="formData" :form-items="formItems">
		      </zj-form-module>
		    </zj-form-container>
		    <div slot="footer" class="dialog-footer">
		      <el-button size="mini" @click="formCancel">取 消</el-button>
		      <el-button size="mini" @click="formConfirm" type="primary">确 定</el-button>
		    </div>
		  </el-dialog>
		<!-- 入驻网点 -->
		<el-dialog title="设为工程师" :visible.sync="dialogVisible" @close="websitList = []" width="40%" :close-on-click-modal="false" :modal-append-to-body="false">
			<el-form ref="workerForm" :model="workerForm" label-width="110px" size="small" label-position="left">
				<el-row :gutter="20">
					<el-col :span="24">
						<el-form-item label="入驻网点" :required="true">
							<el-select v-model="workerForm.websitId" placeholder="请选择" style="width: 100%;">
							    <el-option
							      v-for="item in websitList"
							      :key="item.websitId"
							      :label="item.name"
							      :value="item.websitId">
							    </el-option>
							  </el-select>
						</el-form-item>
					</el-col>
				</el-row>
			</el-form>
			<div slot="footer" class="dialog-footer">
				<el-button @click="dialogVisible = false">取 消</el-button>
				<el-button type="primary" @click="memberInner()">确定</el-button>
			</div>
		</el-dialog>
		</template-page>
		<div class="detail" v-if="isShowMemberDetail">
			<MemberDetail :user="queryUser" @backListFromDetail="backListFromMemberDetail" />
		</div>
	</div>
</template>

<script>
import TemplatePage from '@/components/template/template-page-1.vue'
import import_mixin from '@/components/template/import_mixin.js'
import { required, mobileRequired, mobile } from '@/components/template/rules_verify.js'
import { memberListPageV2,memberPageExport, memberAudit, memberInner, getWebsit } from "@/api/customerManagement";
import MemberDetail from "@/components/Mall/Member/member-detail";
export default {
  components: { TemplatePage, MemberDetail },
  mixins: [import_mixin],
  data() {
    return {
      // 事件组合
      optionsEvensGroup: [],
      // 表格属性
      tableAttributes: {
        // 启用勾选列
        selectColumn: false
      },
      // 表格事件
      tableEvents: {
        'selection-change': this.selectionChange
      },
      // 勾选选中行
      recordSelected: [],
      /** 表单变量 */
      formDialogType: 0,
      formDialogTitles: [],
      formDialog: false,
	  dialogVisible: false,
	  	formData: {
	  		storageName: '',
	  		storageMobile: '',
	  		storageAddress: '',
	  	},
	  websitList: [],
	  workerForm: {
	  			websitId: '',
	  			userId: '',
	  },
	  queryUser: {}, // 查询
    }
  },
  computed: {
    // 更多参数
    moreParameters() {
      return []
    },
    formItems() {
      
    },
	isShowMemberDetail() {
	  return this.queryUser.hasOwnProperty('userId')
	}
  },
  methods: {
    // 列表请求函数
    getList: memberListPageV2,
    // 列表导出函数
    exportList: memberPageExport,
    // 表格列解析渲染数据更改
    columnParsing(item, defaultData) {
      return defaultData
    },
    // 监听勾选变化
    selectionChange(data) {
      this.recordSelected = data
    },
		// 详情返回显示列表
		backListFromMemberDetail() {
		  this.queryUser = {}
		},
    // 表格操作列
    operation(h, { row, index, column }) {
      return (
        <div class='operation-btns'>
			<el-button type="text" onClick={() => {
			  this.queryUser = row
			}}>详情</el-button>
          {row.examineStatus != 'WAIT' ?<el-button type="text" onClick={() => {
          this.workerForm.userId = row.userId
          getWebsit({type: 'C'}).then(res => {
                   this.websitList = res.data
             this.dialogVisible = true
                })
          }}>设为工程师</el-button>:null}
          {row.examineStatus != 'WAIT' ?<el-button type="text" onClick={() => {
				this.$confirm('请确认是否设为分销员, 是否继续?', '提示', {
					confirmButtonText: '确定',
					cancelButtonText: '取消',
					type: 'warning'
				}).then(() => {
					memberInner({
						type: 'SERVICE',
						userIds: row.userId
					}).then(res => {
						if (res.code == 200) {
							this.$message({ type: 'success', message: '设为分销员成功!' })
							this.$refs.pageRef.refreshList()
						} else {
							this.$message.error(res.msg);
						}
					})
				});
			}}>设为分销员</el-button>:null}
        </div>
      )
    },
    addData() {
      this.formDialogType = 0
      this.openForm()
    },
    openForm() {
      this.formDialog = true;
    },
    formCancel() {
      this.$refs.formRef.$refs.inlineForm.clearValidate()
      this.$data.formData = this.$options.data().formData
      this.formDialog = false
    },
	memberInner(){
		if(!this.workerForm.websitId){
			return this.$message({ type: 'danger', message: '请选择入驻网点!' })
		}
		memberInner({
			type: 'WORKER',
			userIds: this.workerForm.userId,
			websitId: this.workerForm.websitId
		}).then(res => {
			this.dialogVisible = false
			this.$message({ type: 'success', message: '设置工程师成功!' })
			this.$refs.pageRef.refreshList()
		})
	},
    formConfirm() {
      this.$refs.formRef.validate((valid, invalidFields, errLabels) => {
        if (valid) {
          ([addMember, editMember][this.formDialogType])(this.formData).then(res => {
            this.$message({ type: 'success', message: `${this.formDialogTitles[this.formDialogType]}成功!` })
            this.formCancel()
            this.$refs.pageRef.refreshList()
          })
        }
      })
    }
  }
}
</script>

<style lang="scss" scoped>
	.detail{
		padding: 20px;
		box-sizing: border-box;
	}
</style>
